---
title: Updating OnlyOffice DocumentServer
description: 
published: true
date: 2025-02-15T21:50:40.224Z
tags: 
editor: markdown
dateCreated: 2025-02-15T21:50:40.224Z
---

# Updating OnlyOffice DocumentServer
We use OnlyOffice for our document editing suite for Nextcloud. We build our own version to apply a few changes, including removing limitations imposed on instances without a license. A forgejo workflow facilitates updates, thus to build a new version we just need to update a few variables and create a new tag. Once pushed, Forgejo Actions will build the server, package it a deb file, and then pushes it to a Debian repo. Thus, once built and pushed, we just need to `apt upgrade` on the server, and voilà, all done.

This differs than our other services, which are packaged and built for Alpine Linux. This was done due to the complexity of the OnlyOffice build system.

## Building OnlyOffice DocumentServer

> $ git clone ssh://git@[forge.ilot.io]:222/ilot/onlyoffice-document-server.git

Update `.forgejo/workflows/release-build.yaml` with new version information. The important variables pkgver (which matches git tag of DocumentServer release) and buildno, which matches the release number of latest tag in DocumentServer's build_tools. For the latter, make sure you use the buildno where version file matches the release you want to build.

You may want to make sure that the patches don't need updating. You can test their application with these series of commands:

> $ git clone https://github.com/ONLYOFFICE/DocumentServer --recursive -b v\$pkgver build
> $ git clone https://github.com/ONLYOFFICE/build_tools.git -b v\$pkgver.\$buildno build/build_tools
> $ cd build
> $ git apply -v --ignore-space-change --ignore-whitespace ../\$patch

Once confirmed, you can add the files and commit the changes. Once that is done, make a new tag using `v$pkgver-$buildno` format, and push. You can follow the progress via the Actions tab on Forge.

## Updating on server

Once the build passes, it is then as simple as going on the OnlyOffice server and `apt upgrade`. It is current pratice to clone the container, and create a new subdomain per version (i.e onlyoffice-82.ilot.io for version 8.2.x), but that is out of the scope of this guide.